/**
 * 用户相关的API
 */
import { IFnContext } from '@cloudbase/weda-node-sdk';
export interface IUserInfo {
    wedaId: string;
    nickName: string;
    avatarUrl: string;
    country: string;
    province: string;
    city: string;
    /** 0: 未知, 1: 男, 2: 女 */
    gender: number;
}
export interface ISignInParams {
    phone?: string;
    userType?: number;
}
/**
 * 登录/注册
 *  用户不存在即注册, 存在即直接返
 *
 *  手机号优先使用接口接收到的
 *   否则, 针对云开发用户则尝试使用 用户信息中的phone
 *        微信用户则尝试使用从 context.weixin.phone(cloudID 换取) 中获取
 *  https://tcloud-dev.oa.com/document/product/1505/57131?!preview&!document=1
 * @param params 用户信息
 * @param context 云函数上下文
 * @returns
 */
export declare function signIn(params: ISignInParams, context: IFnContext): Promise<any>;
/**
 * 获取用户信息
 *  暂时无需参数
 * 用户不存在则返回 null, 注册的微信用户返回 空对象
 */
export declare function getUserInfo(params: any, context: IFnContext): Promise<IUserInfo | null | {}>;
