"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const koa_graphql_1 = __importDefault(require("koa-graphql"));
const load_datasources_1 = require("../../fns/load-datasources");
const config_1 = require("../../config");
const graphqlMiddleware = async (ctx, next) => {
    const schema = await load_datasources_1.loadDataSources();
    const result = await koa_graphql_1.default({ schema, graphiql: config_1.ENABLE_GRAPHQL_UI })(ctx, next);
    // result 的值可能为 null,  koa 中将 ctx.body 设置为 null 即表示将body清空, 后续对其再设置将无效
    //  ref: https://github.com/koajs/koa/issues/998
    if (result !== null)
        ctx.body = result;
};
exports.default = graphqlMiddleware;
